{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bio-client:latest"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil (inputs.file_size / 1048576))",
                    "tmpdirMax": "$(Math.ceil (inputs.file_size / 1048576))",
                    "outdirMin": "$(Math.ceil (inputs.file_size / 1048576))",
                    "outdirMax": "$(Math.ceil (inputs.file_size / 1048576))"
                }
            ],
            "inputs": [
                {
                    "id": "#bio_client_download.cwl/config-file",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-c",
                        "position": 0
                    }
                },
                {
                    "id": "#bio_client_download.cwl/dir_path",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--dir_path",
                        "position": 99
                    }
                },
                {
                    "id": "#bio_client_download.cwl/download",
                    "type": "string",
                    "default": "download",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#bio_client_download.cwl/download_handle",
                    "type": "string",
                    "inputBinding": {
                        "position": 98
                    }
                },
                {
                    "id": "#bio_client_download.cwl/file_size",
                    "type": "long",
                    "default": 1
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bio_client.py"
            ],
            "id": "#bio_client_download.cwl",
            "outputs": [
                {
                    "id": "#bio_client_download.cwl/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup.yml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/FO",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/KS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PI",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/SM",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/flow_cell_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/lane_number",
                                    "type": [
                                        "null",
                                        "long"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/multiplex_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/forward_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/reverse_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/bam",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/forward_fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/reverse_fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/readgroup_meta",
                    "type": "#readgroup.yml/readgroup_meta"
                }
            ],
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_pe_file"
                }
            ],
            "expression": "${\n  var output = { \"forward_fastq\": inputs.forward_fastq,\n                 \"reverse_fastq\": inputs.reverse_fastq,\n                 \"readgroup_meta\": inputs.readgroup_meta\n                 };\n  output.forward_fastq.format = \"edam:format_2182\";\n  output.reverse_fastq.format = \"edam:format_2182\";\n  return {'output': output}\n}\n",
            "id": "#emit_readgroup_fastq_pe_file.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/readgroup_fastq_pe_uuid",
                    "type": "#readgroup.yml/readgroup_fastq_pe_uuid"
                },
                {
                    "id": "#main/bioclient_config",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#main/output",
                    "type": "#readgroup.yml/readgroup_fastq_pe_file",
                    "outputSource": "#main/emit_readgroup_fastq_pe_file/output"
                }
            ],
            "steps": [
                {
                    "id": "#main/extract_forward_fastq",
                    "run": "#bio_client_download.cwl",
                    "in": [
                        {
                            "id": "#main/extract_forward_fastq/config-file",
                            "source": "#main/bioclient_config"
                        },
                        {
                            "id": "#main/extract_forward_fastq/download_handle",
                            "source": "#main/readgroup_fastq_pe_uuid",
                            "valueFrom": "$(self.forward_fastq_uuid)"
                        },
                        {
                            "id": "#main/extract_forward_fastq/file_size",
                            "source": "#main/readgroup_fastq_pe_uuid",
                            "valueFrom": "$(self.forward_fastq_file_size)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_forward_fastq/output"
                        }
                    ]
                },
                {
                    "id": "#main/extract_reverse_fastq",
                    "run": "#bio_client_download.cwl",
                    "in": [
                        {
                            "id": "#main/extract_reverse_fastq/config-file",
                            "source": "#main/bioclient_config"
                        },
                        {
                            "id": "#main/extract_reverse_fastq/download_handle",
                            "source": "#main/readgroup_fastq_pe_uuid",
                            "valueFrom": "$(self.reverse_fastq_uuid)"
                        },
                        {
                            "id": "#main/extract_reverse_fastq/file_size",
                            "source": "#main/readgroup_fastq_pe_uuid",
                            "valueFrom": "$(self.reverse_fastq_file_size)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_reverse_fastq/output"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_fastq_pe_file",
                    "run": "#emit_readgroup_fastq_pe_file.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_fastq_pe_file/forward_fastq",
                            "source": "#main/extract_forward_fastq/output"
                        },
                        {
                            "id": "#main/emit_readgroup_fastq_pe_file/reverse_fastq",
                            "source": "#main/extract_reverse_fastq/output"
                        },
                        {
                            "id": "#main/emit_readgroup_fastq_pe_file/readgroup_meta",
                            "source": "#main/readgroup_fastq_pe_uuid",
                            "valueFrom": "$(self.readgroup_meta)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_fastq_pe_file/output"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
